/***************************************************************************
 * LPRng - An Extended Print Spooler System
 *
 * Copyright 1988-1995 Patrick Powell, San Diego State University
 *     papowell@sdsu.edu
 * See LICENSE for conditions of use.
 *
 ***************************************************************************
 * MODULE: timeout.h
 * PURPOSE: timeout support definitions
 * "$Id: timeout.h,v 1.2 1995/12/16 17:22:16 papowell Exp $"
 **************************************************************************/

#ifndef _TIMEOUT_H 
#define _TIMEOUT_H 

#include <setjmp.h>

EXTERN plp_signal_t (*Old_alarm_fun)(int);      /* save the alarm function */
EXTERN int Alarm_timed_out;                                     /* flag */
EXTERN int *Close_fd;      /* close on timeout */
EXTERN int Timeout_pending;
EXTERN jmp_buf Timeout_env;

#if defined(HAVE_SIGSETJMP)
#define Set_timeout(t,s) (sigsetjmp(Timeout_env,1)==0 && Set_timeout_alarm(t,s))
#else
#define Set_timeout(t,s) (setjmp(Timeout_env)==0 && Set_timeout_alarm(t,s))
#endif

int Set_timeout_alarm( int timeout, int *socket );
void Clear_timeout();
#endif
